#include <amxmodx>
#include <fakemeta>
#include <memhack>


#define PLUGIN "UTF-8 name"
#define VERSION "0.18"
#define AUTHOR "nooby"

#define NAME_CHANGING 0
#define NAME_CHANGED 1

//Զ
#define MAX_NAMES 128

#define ACCESS ADMIN_RESERVATION


new p_enable
new p_access
new p_autoname
new bool: g_status[33][2]
new g_newname[33][32]

new g_total
new namelist[MAX_NAMES][2][32]


public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	p_enable = register_cvar("utf8name", "1")
	p_access = register_cvar("u_needaccess", "0")
	p_autoname = register_cvar("u_autoname", "0")
	register_clcmd("say", "cmdsay")
	register_forward(FM_ClientUserInfoChanged, "fwdClientUserInfoChanged", 0)
}

public plugin_cfg()
{
	set_task(2.2, "read_namelist")
}

stock check_namelist(id)
{
	new name[32]
	get_name(id, name, 31)
	static name_counter
	for (new i = 0; i < g_total; i++)
	{
		if (equali(namelist[i][0], name))
		{
			copy(g_newname[id], 31, namelist[i][1])
			if (is_duplicated(id, namelist[i][1]))
			{
				name_counter = 0
				for (; ;)
				{
					formatex(g_newname[id], 31, "(%d)%s", ++name_counter, namelist[i][1])
					if (!is_duplicated(id, g_newname[id]))
					{
						break
					}
				}
			}
			set_task(5.0, "rename_task", 1132 + id, _, _, "b")
			
			return PLUGIN_CONTINUE
		}
	}
	return PLUGIN_CONTINUE
}

public rename_task(tid)
{
	static id
	id = tid - 1132
	if (is_user_alive(id))
	{
		rename(id)
		remove_task(tid)
	}
	else if (!is_user_connected(id))
	{
		remove_task(tid)
	}
}

public client_putinserver(id)
{
	if (get_pcvar_num(p_autoname) && (get_pcvar_num(p_access) ? (get_user_flags(id) & ACCESS) : 1))
	{
		check_namelist(id)
	}
	return PLUGIN_CONTINUE
}

public read_namelist()
{
	if (!get_pcvar_num(p_autoname))
	{
		return
	}
	g_total = 0
	new data_dir[128]
	new data_file[128]
	get_localinfo("amxx_datadir", data_dir, 127)
	formatex(data_file, 127, "%s/names_utf8.txt", data_dir)
	if (!file_exists(data_file))
	{
		log_amx("Error: can not find names_utf8.txt in data folder.")
		return
	}
	new text[32]
	new line, textlen
	new bool:is_chsname
	
	if (!read_file(data_file ,line++, text, 31, textlen))
	{
		log_amx("names_utf8.txt is empty.")
		return
	}
	else
	{
		if (textlen > 3 && text[0] == -17 && text[1] == -69 && text[2] == -65)//BOM
		{
			copy(text, 31,text[3])
		}
		trim(text)
		if (!(strlen(text) == 0 || text[0] == '/' && text[1] == '/' || text[0] == ';'))
		{
			copy(namelist[g_total][0], 31,text)
			is_chsname = true

		}
	}
	
	while (read_file(data_file, line++, text, 31, textlen))
	{ 
		trim(text)
		if (!(strlen(text) == 0 || text[0] == '/' && text[1] == '/' || text[0] == ';'))
		{
			if (g_total > MAX_NAMES)
			{
				log_amx("Loaded %d name(s). All the rest are ignored.", g_total)
				return
			}
			if (!is_chsname)
			{
				copy(namelist[g_total][0], 31,text)
				is_chsname = true
			}
			else
			{
				copy(namelist[g_total++][1], 31,text)
				is_chsname = false
			}
		}
	}
	log_amx("Loaded %d name(s)", g_total)
}

public cmdsay(id)
{
	if (!get_pcvar_num(p_enable) || !is_user_alive(id))
	{
		return PLUGIN_CONTINUE
	}
	if (get_pcvar_num(p_access) && !(get_user_flags(id) & ACCESS))
	{
		return PLUGIN_CONTINUE
	}
	
	new cmd[38]
	new arg1[5], arg2[32]
	read_args(cmd, 37)
	remove_quotes(cmd)
	if (parse(cmd, arg1, 4, arg2, 31) == 2)
	{
		if (equali(arg1, "name"))
		{
			new i
			new cchr
			for (;;)
			{
				cchr = arg2[i++]
				if (cchr < 0)//UTF-8 character
				{
					break
				}
				else if (cchr == 0)
				{
					set_user_info(id, "name", arg2)
					return PLUGIN_HANDLED
				}
			}
			if (contain(arg2, "\") != -1)
			{
				client_print(id, print_chat, "Invalid name.")
				return PLUGIN_HANDLED
			}
			if (is_duplicated(id, arg2))
			{
				client_print(id, print_chat, "Your nick name should not be the same as other's")
			}
			else
			{
				copy(g_newname[id], 31, arg2)
				rename(id)
			}
			return PLUGIN_HANDLED
		}
	}
	return PLUGIN_CONTINUE
}

public client_disconnect (id)
{
	g_status[id][NAME_CHANGED] = false
	if (task_exists(1132 + id))
	{
		remove_task(1132 + id)
	}
}

public fwdClientUserInfoChanged(id, buffer)
{
	if (g_status[id][NAME_CHANGING])
	{
		g_status[id][NAME_CHANGING] = false
		g_status[id][NAME_CHANGED] = true
	}
	else
	{
		return FMRES_IGNORED
	}
	new i
	new uname[32]
	copy(uname, 31, g_newname[id])
	new offset = get_name_offset(buffer)
	new namelen = strlen(uname)
	for (i = 0; i < namelen; i++)
	{
		memhack_set_char(buffer + offset + i, MEM_NULLBASE, uname[i], MEMTYPE_DATA, MEM_SIGNED)
	}
	return FMRES_IGNORED
}

public rename(id)
{
	/*
	new info[2]
	info[0] = id
	info[1] = get_user_flags(id)
	set_task(1.0, "set_access", _, info , 2)
	*/
	new fakename[32] = "0123456789012345678901234567890"
	fakename[strlen(g_newname[id])] = 0
	set_user_info(id, "name", fakename)
	g_status[id][NAME_CHANGING] = true
}


/*
public set_access(info[2])
{
	new id = info[0]
	if (is_user_connected(id))
	{
		remove_user_flags(id)
		set_user_flags(id, info[1])
	}
}
*/

stock get_name_offset(buffer)
{
	new strtmp1[256]
	copy_infokey_buffer(buffer, strtmp1, 255)
	return contain(strtmp1, "\name\") + 6
}

stock is_duplicated(id, name[32])
{
	new i, player, pnum
	new players[32]
	get_players(players, pnum)
	if (pnum > 32)
	{
		pnum = 32
	}
	
	for (i = 0; i < pnum; i++)
	{
		player = players[i]
		if (id != player && g_status[player][NAME_CHANGED] && equal(g_newname[player], name))
		{
			return 1
		}
	}
	return 0
}

stock get_name(id, name[], len)
{
	new buffer = engfunc(EngFunc_GetInfoKeyBuffer, id)
	new strtmp1[256]
	copy_infokey_buffer(buffer, strtmp1, 255)
	new offset = contain(strtmp1, "\name\") + 6
	new thischr
	new i
	for (;;i++)
	{
		thischr = memhack_get_char(buffer + offset + i, MEM_NULLBASE, MEMTYPE_DATA, MEM_SIGNED)
		if (thischr == '\' || thischr == 0)
		{
			name[i] = 0
			break
		}
		else
		{
			name[i] = thischr
		}
	
	}
	name[len - 1] = 0
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil\\ fcharset134 Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang2052\\ f0\\ fs16 \n\\ par }
*/
